gtk3-0.15.10: Binding to the Gtk+ 3 graphical user interface library

Maintainer | gtk2hs-users@lists.sourceforge.net
Stability | provisional
Portability | portable (depends on GHC)
Safe Haskell | None
Language | Haskell98

Graphics.UI.Gtk.Misc.SizeGroup

Contents

- Detail
- Class Hierarchy
- Types
- Constructors
- Methods
- Attributes

Description

Grouping widgets so they request the same size

Synopsis

- data SizeGroup
- class GObjectClass o => SizeGroupClass o
- castToSizeGroup :: GObjectClass obj => obj -> SizeGroup
- gTypeSizeGroup :: GType
- toSizeGroup :: SizeGroupClass o => o -> SizeGroup
- sizeGroupNew :: SizeGroupMode -> IO SizeGroup
- data SizeGroupMode
  - = SizeGroupNone
  - | SizeGroupHorizontal
  - | SizeGroupVertical
  - | SizeGroupBoth
- sizeGroupSetMode :: SizeGroupClass self => self -> SizeGroupMode -> IO ()
- sizeGroupGetMode :: SizeGroupClass self => self -> IO SizeGroupMode
- sizeGroupAddWidget :: (SizeGroupClass self, WidgetClass widget) => self -> widget -> IO ()
- sizeGroupRemoveWidget :: (SizeGroupClass self, WidgetClass widget) => self -> widget -> IO ()
- sizeGroupSetIgnoreHidden :: SizeGroupClass self => self -> Bool -> IO ()
- sizeGroupGetIgnoreHidden :: SizeGroupClass self => self -> IO Bool
- sizeGroupMode :: SizeGroupClass self => Attr self SizeGroupMode
- sizeGroupIgnoreHidden :: SizeGroupClass self => Attr self Bool

# Detail

`SizeGroup` provides a mechanism for grouping a number of widgets together so they all request the same amount of space. This is typically useful when you want a column of widgets to have the same size, but you can't use a `Table` widget.

In detail, the size requested for each widget in a `SizeGroup` is the maximum of the sizes that would have been requested for each widget in the size group if they were not in the size group. The mode of the size group (see `sizeGroupSetMode`) determines whether this applies to the horizontal size, the vertical size, or both sizes.

Note that size groups only affect the amount of space requested, not the size that the widgets finally receive. If you want the widgets in a `SizeGroup` to actually be the same size, you need to pack them in such a way that they get the size they request and not more. For example, if you are packing your widgets into a table, you would not include the `Fill` flag.

Widgets can be part of multiple size groups; Gtk+ will compute the horizontal size of a widget from the horizontal requisition of all widgets that can be reached from the widget by a chain of size groups of type `SizeGroupHorizontal` or `SizeGroupBoth`, and the vertical size from the vertical requisition of all widgets that can be reached from the widget by a chain of size groups of type `SizeGroupVertical` or `SizeGroupBoth`.

# Class Hierarchy

    | GObject
    | +----SizeGroup

# Types

data SizeGroup Source #

#### Instances

Instances details

Eq SizeGroup Source # |
Instance details Defined in Graphics.UI.Gtk.Types Methods (==) :: SizeGroup -> SizeGroup -> Bool Source # (/=) :: SizeGroup -> SizeGroup -> Bool Source #
Ord SizeGroup Source # |

Instance details

Defined in Graphics.UI.Gtk.Types

Methods

compare :: SizeGroup -> SizeGroup -> Ordering Source #

(<) :: SizeGroup -> SizeGroup -> Bool Source #

(<=) :: SizeGroup -> SizeGroup -> Bool Source #

(>) :: SizeGroup -> SizeGroup -> Bool Source #

(>=) :: SizeGroup -> SizeGroup -> Bool Source #

max :: SizeGroup -> SizeGroup -> SizeGroup Source #

min :: SizeGroup -> SizeGroup -> SizeGroup Source #

GObjectClass SizeGroup Source # |
Instance details Defined in Graphics.UI.Gtk.Types Methods toGObject :: SizeGroup -> GObject Source # unsafeCastGObject :: GObject -> SizeGroup Source #
SizeGroupClass SizeGroup Source # |
Instance details Defined in Graphics.UI.Gtk.Types

class GObjectClass o => SizeGroupClass o Source #

#### Instances

Instances details

SizeGroupClass SizeGroup Source # |
Instance details Defined in Graphics.UI.Gtk.Types

castToSizeGroup :: GObjectClass obj => obj -> SizeGroup Source #

gTypeSizeGroup :: GType Source #

toSizeGroup :: SizeGroupClass o => o -> SizeGroup Source #

# Constructors

sizeGroupNew Source #

Arguments

:: SizeGroupMode | `mode` - the mode for the new size group.
-> IO SizeGroup |

Create a new `SizeGroup`.

# Methods

data SizeGroupMode Source #

Constructors

SizeGroupNone |
SizeGroupHorizontal |
SizeGroupVertical |
SizeGroupBoth |

#### Instances

Instances details

Enum SizeGroupMode Source # |

Instance details

Defined in Graphics.UI.Gtk.Misc.SizeGroup

Methods

succ :: SizeGroupMode -> SizeGroupMode Source #

pred :: SizeGroupMode -> SizeGroupMode Source #

toEnum :: Int -> SizeGroupMode Source #

fromEnum :: SizeGroupMode -> Int Source #

enumFrom :: SizeGroupMode -> [SizeGroupMode] Source #

enumFromThen :: SizeGroupMode -> SizeGroupMode -> [SizeGroupMode] Source #

enumFromTo :: SizeGroupMode -> SizeGroupMode -> [SizeGroupMode] Source #

enumFromThenTo :: SizeGroupMode -> SizeGroupMode -> SizeGroupMode -> [SizeGroupMode] Source #

sizeGroupSetMode Source #

Arguments

:: SizeGroupClass self |
=> self |
-> SizeGroupMode | `mode` - the mode to set for the size group.
-> IO () |

Sets the `SizeGroupMode` of the size group. The mode of the size group determines whether the widgets in the size group should all have the same horizontal requisition `SizeGroupHorizontal` all have the same vertical requisition `SizeGroupVertical`, or should all have the same requisition in both directions `SizeGroupBoth`.

sizeGroupGetMode Source #

Arguments

:: SizeGroupClass self |
=> self |
-> IO SizeGroupMode | returns the current mode of the size group.

Gets the current mode of the size group. See `sizeGroupSetMode`.

sizeGroupAddWidget Source #

Arguments

:: (SizeGroupClass self, WidgetClass widget) |
=> self |
-> widget | `widget` - the `Widget` to add
-> IO () |

Adds a widget to a `SizeGroup`. In the future, the requisition of the widget will be determined as the maximum of its requisition and the requisition of the other widgets in the size group. Whether this applies horizontally, vertically, or in both directions depends on the mode of the size group. See `sizeGroupSetMode`.

sizeGroupRemoveWidget Source #

Arguments

:: (SizeGroupClass self, WidgetClass widget) |
=> self |
-> widget | `widget` - the `Widget` to remove
-> IO () |

Removes a widget from a `SizeGroup`.

sizeGroupSetIgnoreHidden Source #

Arguments

:: SizeGroupClass self |
=> self |
-> Bool | `ignoreHidden` - whether hidden widgets should be ignored when calculating the size
-> IO () |

Sets whether invisible widgets should be ignored when calculating the size.

- Available since Gtk+ version 2.8

sizeGroupGetIgnoreHidden Source #

Arguments

:: SizeGroupClass self |
=> self |
-> IO Bool | returns `True` if invisible widgets are ignored.

Returns if invisible widgets are ignored when calculating the size.

- Available since Gtk+ version 2.8

# Attributes

sizeGroupMode :: SizeGroupClass self => Attr self SizeGroupMode Source #

The directions in which the size group affects the requested sizes of its component widgets.

Default value: `SizeGroupHorizontal`

sizeGroupIgnoreHidden :: SizeGroupClass self => Attr self Bool Source #

If `True`, hidden widgets are ignored when determining the size of the group.

Default value: `False`